#coding: utf-8
# +-------------------------------------------------------------------
# | 宝塔Windows面板 
# +-------------------------------------------------------------------
# | Copyright (c) 2015-2099 宝塔软件(http://bt.cn) All rights reserved.
# +-------------------------------------------------------------------
# | Author: 曹觉心 <314866873@qq.com>
# +-------------------------------------------------------------------

#--------------------------------
# 宝塔公共库
#--------------------------------


import json,os,sys,time,re,win32service,winreg,psutil,xmltodict
import win32serviceutil as service
from xml.dom import minidom

def M(table):
    import db
    sql = db.Sql()
    return sql.table(table);

def HttpGet(url,timeout = 60):
    """
    发送GET请求
    @url 被请求的URL地址(必需)
    @timeout 超时时间默认60秒
    return string
    """
    if sys.version_info[0] == 2:
        try:
            import urllib2,ssl
            if sys.version_info[0] == 2:
                reload(urllib2)
                reload(ssl)
            try:
                ssl._create_default_https_context = ssl._create_unverified_context
            except:pass;
            response = urllib2.urlopen(url,timeout=timeout)
            return response.read()
        except Exception as ex:
            return str(ex);
    else:
        try:
            import urllib,ssl
            try:
                ssl._create_default_https_context = ssl._create_unverified_context
            except:pass;
            response = urllib.request.urlopen(url,timeout=timeout)
            result = response.read()
            if type(result) == bytes: result = result.decode('utf-8')
            return result
        except Exception as ex:
            return str(ex)


def httpGet(url,timeout=60):
    return HttpGet(url,timeout)


def HttpPost(url,data,timeout = 60):
    """
    发送POST请求
    @url 被请求的URL地址(必需)
    @data POST参数，可以是字符串或字典(必需)
    @timeout 超时时间默认60秒
    return string
    """
    if sys.version_info[0] == 2:
        try:
            import urllib,urllib2,ssl
            if sys.version_info[0] == 2:
                reload(urllib)
                reload(urllib2)
            try:
                ssl._create_default_https_context = ssl._create_unverified_context
            except:pass;
            data = urllib.urlencode(data)
            req = urllib2.Request(url, data)
            response = urllib2.urlopen(req,timeout = timeout)
            return response.read()
        except Exception as ex:
            return str(ex);
    else:
        try:
            import urllib,ssl
            try:
                ssl._create_default_https_context = ssl._create_unverified_context
            except:pass;
            data = urllib.parse.urlencode(data).encode('utf-8')
            if url.find('http://www.bt.cn') != -1: url = url.replace('http://www.bt.cn','https://www.bt.cn')

            req = urllib.request.Request(url, data)
            response = urllib.request.urlopen(req,timeout = timeout)
            result = response.read()
            if type(result) == bytes: result = result.decode('utf-8')
            return result
        except Exception as ex:
            return str(ex);

def httpPost(url,data,timeout=60):
    return HttpPost(url,data,timeout)

def Md5(strings):
    """
    生成MD5
    @strings 要被处理的字符串
    return string(32)
    """
    import hashlib
    m = hashlib.md5()
    m.update(strings.encode('utf-8'))
    return m.hexdigest()

def md5(strings):
    return Md5(strings)

def FileMd5(filename):
    """
    生成文件的MD5
    @filename 文件名
    return string(32) or False
    """
    if not os.path.isfile(filename): return False;
    import hashlib;
    my_hash = hashlib.md5()
    f = file(filename,'rb')
    while True:
        b = f.read(8096)
        if not b :
            break
        my_hash.update(b)
    f.close()
    return my_hash.hexdigest();


def GetRandomString(length):
    """
       取随机字符串
       @length 要获取的长度
       return string(length)
    """
    from random import Random
    strings = ''
    chars = 'AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz0123456789'
    chrlen = len(chars) - 1
    random = Random()
    for i in range(length):
        strings += chars[random.randint(0, chrlen)]
    return strings

#兼容英文系统
def bt_print(msg):
    try:
        print(msg)
    except :
        try:
            print(msg,msg.encode('utf-8'))
        except :
            pass

def ReturnJson(status,msg,args=()):
    """
    取通用Json返回
    @status  返回状态
    @msg  返回消息
    return string(json)
    """
    return GetJson(ReturnMsg(status,msg,args));

def returnJson(status,msg,args=()):
    return ReturnJson(status,msg,args)

def ReturnMsg(status,msg,args = ()):
    log_message = json.loads(ReadFile('BTPanel/static/language/' + GetLanguage() + '/public.json'));
    keys = log_message.keys();
    if type(msg) == str:
        if msg in keys:
            msg = log_message[msg];
            for i in range(len(args)):
                rep = '{'+str(i+1)+'}'
                msg = msg.replace(rep,args[i]);
    return {'status':status,'msg':msg}

def returnMsg(status,msg,args = ()):
    return ReturnMsg(status,msg,args)


def GetFileMode(filename):
    '''取文件权限'''
    stat = os.stat(filePath)
    accept = str(oct(stat.st_mode)[-3:]);
    return accept

def GetJson(data):
    """
    将对象转换为JSON
    @data 被转换的对象(dict/list/str/int...)
    """
    from json import dumps
    return dumps(data)

def getJson(data):
    return GetJson(data)

def get_str_code(f_body):
    from chardet.universaldetector import UniversalDetector
    detector = UniversalDetector()
    detector.feed(f_body)
    detector.close()
    char = detector.result
    return char;

def ReadFile(filename,mode = 'r'):
    """
    读取文件内容
    @filename 文件名
    return string(bin) 若文件不存在，则返回None
    """

    import os
    if not os.path.exists(filename): return False
    try:
        fp = open(filename, mode,encoding = 'utf-8')
        f_body = fp.read()
    except :
        try:
            fp = open(filename, mode,encoding = 'gbk')
            f_body = fp.read()
        except :
            fp = open(filename, mode,encoding = 'ansi')
            f_body = fp.read()
    
    fp.close()   
    return f_body

def readFile(filename,mode='r'):
    return ReadFile(filename,mode)

def WriteFile(filename,s_body,mode='w+',encoding = 'utf-8'):
    """
    写入文件内容
    @filename 文件名
    @s_body 欲写入的内容
    return bool 若文件不存在则尝试自动创建
    """
    try:
        fp = open(filename, mode,encoding = encoding);
        fp.write(s_body)
        fp.close()
        return True
    except:
        return False

def writeFile(filename,s_body,mode='w+',encoding = 'utf-8'):
    return WriteFile(filename,s_body,mode,encoding)

def writeFile2(filename,s_body,mode='w+'):
    """
    写入字节文件内容
    @filename 文件名
    @s_body 欲写入的内容
    
    """
    try:
        fp = open(filename, mode);
        fp.write(s_body)
        fp.close()
        return True
    except:
        return False

def WriteLog(type,logMsg,args=()):
    #写日志
    #try:
    import time,db,json
    logMessage = json.loads(readFile('BTPanel/static/language/' + get_language() + '/log.json'));
    keys = logMessage.keys();
    if logMsg in keys:
        logMsg = logMessage[logMsg];
        for i in range(len(args)):
            rep = '{'+str(i+1)+'}'
            logMsg = logMsg.replace(rep,args[i]);
    if type in keys: type = logMessage[type];
    sql = db.Sql()
    mDate = time.strftime('%Y-%m-%d %X',time.localtime());
    data = (type,logMsg,mDate);
    result = sql.table('logs').add('type,log,addtime',data);
    #except:
        #pass

def GetLanguage():
    '''
    取语言
    '''
    return GetConfigValue("language")

def get_language():
    return GetLanguage()

def GetConfigValue(key):
    '''
    取配置值
    '''
    config = GetConfig()
    if not key in config.keys(): return None
    return config[key]

def SetConfigValue(key,value):
    config = GetConfig()
    config[key] = value
    WriteConfig(config)

def GetConfig():
    '''
    取所有配置项
    '''
    path = "config/config.json"
    if not os.path.exists(path): return {}
    f_body = ReadFile(path)
    if not f_body: return {}
    return json.loads(f_body)

def WriteConfig(config):
    path = "config/config.json"
    WriteFile(path,json.dumps(config))


def GetLan(key):
    """
    取提示消息
    """
    log_message = json.loads(ReadFile('BTPanel/static/language/' + GetLanguage() + '/template.json'));
    keys = log_message.keys();
    msg = None;
    if key in keys:
        msg = log_message[key];
    return msg;
def getLan(key):
    return GetLan(key)

def GetMsg(key,args = ()):
    try:
        log_message = json.loads(ReadFile('BTPanel/static/language/' + GetLanguage() + '/public.json'));
        keys = log_message.keys();
        msg = None;
        if key in keys:
            msg = log_message[key];
            for i in range(len(args)):
                rep = '{'+str(i+1)+'}'
                msg = msg.replace(rep,args[i]);
        return msg;
    except:
        return key
def getMsg(key,args = ()):
    return GetMsg(key,args)

def get_error_info():
    import traceback
    errorMsg = traceback.format_exc();
    return errorMsg

#获取Web服务器
def GetWebServer():
    webserver = 'iis';
    if get_server_status('nginx') >= 0:
        webserver = 'nginx'
    elif get_server_status('apache') >= 0:
        webserver = 'apache';
    return webserver;

def get_webserver():
    return GetWebServer()


def ServiceReload():
    #重载Web服务配置
    webserver = get_webserver()
    if webserver == 'nginx':
        os.system("taskkill /im nginx.exe /f")
        result = ExecShell("net start nginx");
    elif webserver == 'apache':
        os.system("taskkill /im httpd.exe /f")
        result = ExecShell("net start apache");
    else:
        result = ExecShell('iisreset')
    return result;
def serviceReload():
    return ServiceReload()


def ExecShell(cmdstring, cwd=None, timeout=None, shell=True):
    #通过管道执行SHELL
    import shlex
    import datetime
    import subprocess
    import time

    if shell:
        cmdstring_list = cmdstring
    else:
        cmdstring_list = shlex.split(cmdstring)
    
    if timeout:
        end_time = datetime.datetime.now() + datetime.timedelta(seconds=timeout)
    
    sub = subprocess.Popen(cmdstring_list, cwd=cwd, stdin=subprocess.PIPE,shell=shell,bufsize=4096,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
    
    while sub.poll() is None:
        time.sleep(0.1)
        if timeout:
            if end_time <= datetime.datetime.now():
                raise Exception("Timeout：%s"%cmdstring)
    a,e = sub.communicate()
    if type(a) == bytes: a = a.decode('gb2312')
    if type(e) == bytes: e = e.decode('gb2312')
    return a,e

def ExecPowerShell(cmdstring, cwd=None, timeout=None, shell=True):
    #通过管道执行SHELL
    import shlex
    import datetime
    import subprocess
    import time

    if shell:
        cmdstring_list = cmdstring
    else:
        cmdstring_list = shlex.split(cmdstring)
    
    if timeout:
        end_time = datetime.datetime.now() + datetime.timedelta(seconds=timeout)
    
    sub = subprocess.Popen(cmdstring_list, cwd=cwd, shell=shell,bufsize=4096,stdout=subprocess.PIPE,stderr=subprocess.PIPE)
    
    while sub.poll() is None:
        time.sleep(0.1)
        if timeout:
            if end_time <= datetime.datetime.now():
                raise Exception("Timeout：%s"%cmdstring)
    a,e = sub.communicate()
    if type(a) == bytes: a = a.decode('gb2312')
    if type(e) == bytes: e = e.decode('gb2312')
    return a,e

def GetLocalIp():
    #取本地外网IP
    try:
        filename = os.getenv('BT_PANEL') + '/data/iplist.txt'
        ipaddress = readFile(filename)
        if not ipaddress:
           
            url = 'http://pv.sohu.com/cityjson?ie=utf-8'
            str = httpGet(url)
            ipaddress = re.search('\d+.\d+.\d+.\d+',str).group(0)
            WriteFile(filename,ipaddress)
        
        ipaddress = re.search('\d+.\d+.\d+.\d+',ipaddress).group(0);
        return ipaddress
    except:
        try:
            url =  'http://www.bt.cn/Api/getIpAddress';
            str = httpGet(url)
            return str
        except:
            return GetHost();

def GetHost(port = False):
    from flask import request
    h = request.headers.get('host').split(':')
    if port: return h[1]
    return h[0]

def GetClientIp():
    from flask import request
    return request.remote_addr

def phpReload(version):
    #重载PHP配置
    serviceReload()

def get_url(timeout = 0.5):
    import json
    try:
        nodeFile = 'data/node.json';
        node_list = json.loads(readFile(nodeFile));
        mnode = None
        for node in node_list:
            node['ping'] = get_timeout(node['protocol'] + node['address'] + ':' + node['port'] + '/check.txt');
            if not node['ping']: continue;
            if not mnode: mnode = node;
            if node['ping'] < mnode['ping']: mnode = node;
        return mnode['protocol'] + mnode['address'] + ':' + mnode['port'];
    except:
        return 'http://download.bt.cn';


#过滤输入
def checkInput(data):
   if not data: return data;
   if type(data) != str: return data;
   checkList = [
                {'d':'<','r':'＜'},
                {'d':'>','r':'＞'},
                {'d':'\'','r':'‘'},
                {'d':'"','r':'“'},
                {'d':'&','r':'＆'},
                {'d':'#','r':'＃'},
                {'d':'<','r':'＜'}
                ]
   for v in checkList:
       data = data.replace(v['d'],v['r']);
   return data;


#取文件指定尾行数
def GetNumLines(path,num,p=1):
    pyVersion = sys.version_info[0]
    try:
        import cgi
        if not os.path.exists(path): return "";
        start_line = (p - 1) * num;
        count = start_line + num;
        fp = open(path,'rb')
        buf = ""
        fp.seek(-1, 2)
        if fp.read(1) == "\n": fp.seek(-1, 2)
        data = []
        b = True
        n = 0;
        for i in range(count):
            while True:
                newline_pos = str.rfind(str(buf), "\n")
                pos = fp.tell()
                if newline_pos != -1:
                    if n >= start_line:
                        line = buf[newline_pos + 1:]
                        try:
                            data.insert(0,cgi.escape(line))
                        except: pass
                    buf = buf[:newline_pos]
                    n += 1;
                    break;
                else:
                    if pos == 0:
                        b = False
                        break
                    to_read = min(4096, pos)
                    fp.seek(-to_read, 1)
                    t_buf = fp.read(to_read)
                    if pyVersion == 3:
                        try:
                            if type(t_buf) == bytes: t_buf = t_buf.decode('gbk')
                        except:t_buf = str(t_buf)
                    buf = t_buf + buf
                    fp.seek(-to_read, 1)
                    if pos - to_read == 0:
                        buf = "\n" + buf
            if not b: break;
        fp.close()
    except: return []
    return "\n".join(data)

#验证证书
def CheckCert(certPath = 'ssl/certificate.pem'):
    openssl = '/usr/local/openssl/bin/openssl';
    if not os.path.exists(openssl): openssl = 'openssl';
    certPem = readFile(certPath);
    s = "\n-----BEGIN CERTIFICATE-----";
    tmp = certPem.strip().split(s)
    for tmp1 in tmp:
        if tmp1.find('-----BEGIN CERTIFICATE-----') == -1:  tmp1 = s + tmp1;
        writeFile(certPath,tmp1);
        result = ExecShell(openssl + " x509 -in "+certPath+" -noout -subject")
        if result[1].find('-bash:') != -1: return True
        if len(result[1]) > 2: return False
        if result[0].find('error:') != -1: return False;
    return True;


 # 获取面板地址
def getPanelAddr():
    from flask import request
    protocol = 'https://' if os.path.exists("data/ssl.pl") else 'http://'
    return protocol + request.headers.get('host')


#字节单位转换
def to_size(size):
    d = ('b','KB','MB','GB','TB');
    s = d[0];
    for b in d:
        if size < 1024: return str(round(size,2)) + ' ' + b;
        size = size / 1024;
        s = b;
    return str(round(size,2)) + ' ' + b;

def get_size(size):
    d = ('b','K','M','G','T');
    s = d[0];
    for b in d:
        if size < 1024: return str(round(size,2)) + ' ' + b;
        size = size / 1024;
        s = b;
    return str(round(size,2)) + ' ' + b;

def checkCode(code,outime = 120):
    #校验验证码
    from BTPanel import session,cache
    try:
        codeStr = cache.get('codeStr')
        cache.delete('codeStr')
        if not codeStr:
            session['login_error'] = GetMsg('CODE_TIMEOUT')
            return False

        if md5(code.lower()) != codeStr:
            session['login_error'] = GetMsg('CODE_ERR')
            return False
        return True
    except:
        session['login_error'] = GetMsg('CODE_NOT_EXISTS')
        return False

#写进度
def writeSpeed(title,used,total,speed = 0):
    import json
    if not title:
        data = {'title':None,'progress':0,'total':0,'used':0,'speed':0}
    else:
        progress = int((100.0 * used / total));
        data = {'title':title,'progress':progress,'total':total,'used':used,'speed':speed}
    writeFile('data/panelSpeed.pl',json.dumps(data));
    return True;

#取进度
def getSpeed():
    import json;
    data = readFile('data/panelSpeed.pl');
    if not data: 
        data = json.dumps({'title':None,'progress':0,'total':0,'used':0,'speed':0})
        writeFile('data/panelSpeed.pl',data);
    return json.loads(data);

def downloadFile(url,filename):
   
    bt_print('准备下载文件[' + os.path.basename(filename) + ']')
    if sys.version_info[0] == 2:
        import urllib
        urllib.urlretrieve(url,filename=filename ,reporthook= downloadHook)
    else:
        import urllib.request
        urllib.request.urlretrieve(url,filename=filename ,reporthook= downloadHook)
    
def downloadHook(count, blockSize, totalSize):
    speed = {'total':totalSize,'block':blockSize,'count':count}
    bt_print(to_size(count * blockSize) + '.......... .......... .......... ..........' + str(int(100.0 * count * blockSize / totalSize))+'%')


#搜索数据中是否存在
def inArray(arrays,searchStr):
    for key in arrays:
        if key == searchStr: return True
    
    return False

#检查Web服务器配置文件是否有错误
def checkWebConfig():
    if get_webserver() == 'nginx':
        result = ExecShell("ulimit -n 10240 && /www/server/nginx/sbin/nginx -t -c /www/server/nginx/conf/nginx.conf");
        searchStr = 'successful'
    else:
        result = ExecShell("ulimit -n 10240 && /www/server/apache/bin/apachectl -t");
        searchStr = 'Syntax OK'
    
    if result[1].find(searchStr) == -1:
        WriteLog("TYPE_SOFT", 'CONF_CHECK_ERR',(result[1],));
        return result[1];
    return True;

#检查Web服务器配置文件是否有错误
def checkWebConfig():
    if get_webserver() == 'nginx':
        result = ExecShell("ulimit -n 10240 && /www/server/nginx/sbin/nginx -t -c /www/server/nginx/conf/nginx.conf");
        searchStr = 'successful'
    else:
        result = ExecShell("ulimit -n 10240 && /www/server/apache/bin/apachectl -t");
        searchStr = 'Syntax OK'
    
    if result[1].find(searchStr) == -1:
        WriteLog("TYPE_SOFT", 'CONF_CHECK_ERR',(result[1],));
        return result[1];
    return True;

#检查是否为IPv4地址
def checkIp(ip):
    p = re.compile('^((25[0-5]|2[0-4]\d|[01]?\d\d?)\.){3}(25[0-5]|2[0-4]\d|[01]?\d\d?)$')  
    if p.match(ip):  
        return True  
    else:  
        return False
    
#检查端口是否合法
def checkPort(port):
    ports = ['21','25','443','8080','888','8888','8443'];
    if port in ports: return False;
    intport = int(port);
    if intport < 1 or intport > 65535: return False;
    return True;

#字符串取中间
def getStrBetween(startStr,endStr,srcStr):
    start = srcStr.find(startStr)
    if start == -1: return None
    end = srcStr.find(endStr)
    if end == -1: return None
    return srcStr[start+1:end]

#取CPU类型
def getCpuType():
    cpuType = ReadReg(r'HARDWARE\DESCRIPTION\System\CentralProcessor\0','ProcessorNameString')
    return cpuType;


#检查是否允许重启
def IsRestart():
    num  = M('tasks').where('status!=?',('1',)).count();
    if num > 0: return False;
    return True;

#加密密码字符
def hasPwd(password):
    import crypt;
    return crypt.crypt(password,password);

def get_timeout(url):
    start = time.time();
    result = httpGet(url);
    if result != 'True': return False;
    return int((time.time() - start) * 1000);

def getDate(format='%Y-%m-%d %X'):
    #取格式时间
    return time.strftime(format,time.localtime())


#检查端口是否合法
def CheckPort(port,other=None):
    if type(port) == str: port = int(port)
    if port < 1 or port > 65535: return False
    if other:
        checks = [22,20,21,8888,3306,11211,888,25]
        if port in checks: return False
    return True

#获取Token
def GetToken():
    try:
        from json import loads
        tokenFile = 'data/token.json';
        if not os.path.exists(tokenFile): return False;
        token = loads(public.readFile(tokenFile));
        return token;
    except:
        return False


def load_module(pluginCode):
    from imp import new_module
    from BTPanel import cache
    pluginInfo = cache.get(pluginCode+'code')
    pluginInfo = None
    if not pluginInfo:
        import panelAuth
        pdata = panelAuth.panelAuth().create_serverid(None)
        pdata['pid'] = pluginCode
        url = GetConfigValue('home') + '/api/panel/get_py_module'
        pluginTmp = httpPost(url,pdata)
        pluginInfo = json.loads(pluginTmp)
        if pluginInfo['status'] == False: return False
        cache.set(pluginCode+'code',pluginInfo,1800)

    mod = sys.modules.setdefault(pluginCode, new_module(pluginCode))
    code = compile(pluginInfo['msg'].encode('utf-8'),pluginCode, 'exec')
    mod.__file__ = pluginCode
    mod.__package__ = ''
    exec(code, mod.__dict__)
    return mod

#解密数据
def auth_decode(data):
    token = GetToken()
    #是否有生成Token
    if not token: return returnMsg(False,'REQUEST_ERR')
    
    #校验access_key是否正确
    if token['access_key'] != data['btauth_key']: return returnMsg(False,'REQUEST_ERR')
    
    #解码数据
    import binascii,hashlib,urllib,hmac,json
    tdata = binascii.unhexlify(data['data']);
    
    #校验signature是否正确
    signature = binascii.hexlify(hmac.new(token['secret_key'], tdata, digestmod=hashlib.sha256).digest());
    if signature != data['signature']: return returnMsg(False,'REQUEST_ERR');
    
    #返回
    return json.loads(urllib.unquote(tdata));
    

#数据加密
def auth_encode(data):
    token = GetToken()
    pdata = {}
    
    #是否有生成Token
    if not token: return returnMsg(False,'REQUEST_ERR')
    
    #生成signature
    import binascii,hashlib,urllib,hmac,json
    tdata = urllib.quote(json.dumps(data));
    #公式  hex(hmac_sha256(data))
    pdata['signature'] = binascii.hexlify(hmac.new(token['secret_key'], tdata, digestmod=hashlib.sha256).digest());
    
    #加密数据
    pdata['btauth_key'] = token['access_key'];
    pdata['data'] = binascii.hexlify(tdata);
    pdata['timestamp'] = time.time()
    
    #返回
    return pdata;

#检查Token
def checkToken(get):
    tempFile = 'data/tempToken.json'
    if not os.path.exists(tempFile): return False
    import json,time
    tempToken = json.loads(readFile(tempFile))
    if time.time() > tempToken['timeout']: return False
    if get.token != tempToken['token']: return False
    return True;


#进程是否存在
def process_exists(pname,exe = None):
    try:
        pids = psutil.pids()
        for pid in pids:
            try:
                p = psutil.Process(pid)
                if p.name() == pname: 
                    if not exe:
                        return True;
                    else:
                        if p.exe() == exe: return True
            except:pass
        return False
    except: return True

#获取系统版本
def get_sys_version():
    import platform
    v = platform.version()
    arrs = v.split('.')
    arrs.append(v)
    return arrs

#重启面板
def restart_panel():
    import system
    return system.system().ReWeb(None)

#获取mac
def get_mac_address():
    import uuid
    mac=uuid.UUID(int = uuid.getnode()).hex[-12:]
    return ":".join([mac[e:e+2] for e in range(0,11,2)])


#转码
def to_string(lites):
    if type(lites) != list: lites = [lites]
    m_str = ''
    for mu in lites:
        if sys.version_info[0] == 2:
            m_str += unichr(mu).encode('utf-8')
        else:
            m_str += chr(mu)
    return m_str


#写入/创建注册表
def WriteReg(path,key,value):
    import winreg
    try:
        newKey = winreg.OpenKey(winreg.HKEY_LOCAL_MACHINE ,path, 0 ,winreg.KEY_ALL_ACCESS)
    except :
        newKey = winreg.CreateKey(winreg.HKEY_LOCAL_MACHINE ,path)

    try:
        #SetValue 只支持字符串，其他类型使用SetValueEx
        if isinstance(value,int):
            winreg.SetValueEx(newKey,key,0,winreg.REG_DWORD,value)              
        else:
            winreg.SetValue(newKey,key,winreg.REG_SZ,value)
        return True
    except :
        return False

#读取注册表
def ReadReg(path,key):
    import winreg
    try:
        newKey = winreg.OpenKey(winreg.HKEY_LOCAL_MACHINE ,path)
        value,type = winreg.QueryValueEx(newKey, key)
        return value
    except :
        return False      

#删除注册表
def DelReg(path,key):
    import winreg
    try:
        newKey = winreg.OpenKey(winreg.HKEY_LOCAL_MACHINE ,path)
        winreg.DeleteKey(newKey,key)
        return True
    except :
        return False


def set_system_path(key,val):
    public.ExecShell('setx /m '+ key +' "'+ val +'"')
    if os.environ.get(key):
        return True
    return False

def create_server(name, disName, path, args = None, description = None,userName = None,password = None):
    #try:
    import win32service
    if userName and userName.find('.\\') < 0:
        userName = '.\\' + userName
    path = path.replace('/','\\')
    service.InstallService(name,name, disName,win32service.SERVICE_AUTO_START, errorControl = None, bRunInteractive = 0, serviceDeps = None, userName = userName, password = password, exeName = path, perfMonIni = None, perfMonDll = None, exeArgs = args, description = description , delayedstart = None)
    if get_server_status(name) > -1:
        set_server_status(name,'start')
        return True
    #    return False
    #except :
    #    return False

#修改服务状态 （1：自动 0：手动 -1：禁用）
def change_server_start_type(name,type):
    try:
        startType = None
        if type == -1:
            startType = win32service.SERVICE_DISABLED
        elif type == 1:
            startType = win32service.SERVICE_AUTO_START
        else:
            startType = win32service.SERVICE_DEMAND_START

        scm = win32service.OpenSCManager(None, None,win32service.SC_MANAGER_ALL_ACCESS)
        if scm:
            svc = win32service.OpenService(scm, name,win32service.SC_MANAGER_ALL_ACCESS)
            if svc:
                win32service.ChangeServiceConfig(svc, win32service.SERVICE_NO_CHANGE,startType, win32service.SERVICE_NO_CHANGE, None, None, 0, None, None, None, None)
                return True        
    except :
        pass
    return False

#获取服务状态 （-1：未安装 0：未启动 1：已启动）
def get_server_status(name):
     try:
         serviceStatus = service.QueryServiceStatus(name)
         if serviceStatus[1] == 4:
             return 1
         return 0
     except :
         return -1

def set_server_status(name,status):
    old_status = get_server_status(name)
    if old_status > -1:
         #try:
        if status == 'reload' or status == 'restart':
            
            if old_status == 1: 
                service.StopService(name)    
                time.sleep(2);                  
            service.StartService(name)
        else:
            if status == 'start':
                if old_status == 0: 
                    service.StartService(name)
                    time.sleep(2);  
            else:
                if old_status == 1: 
                    service.StopService(name)
                    time.sleep(2);  
        return True
         #except :
         #    return False
    return False

def delete_server(name):
    try:
        status = get_server_status(name)
        if status > -1:
            if status == 1:
                service.StopService(name)
            service.RemoveService(name)
        return True
    except :
        return False

def get_server_path(name):
    data = psutil.win_service_get(name).as_dict()
    path = data['binpath'].split(' ')[0].replace('"','')
    return path


def is_64bitos():
    import platform
    bites = {'AMD64':64, 'x86_64': 64, 'i386': 32, 'x86': 32}
    info = platform.uname()
    if bites.get(info.machine) == 64:
        return True
    return False

def get_appSetup(path,arrs):
    key = winreg.OpenKey(winreg.HKEY_LOCAL_MACHINE,path)        
    countkey = winreg.QueryInfoKey(key)[0]
    for i in range(int(countkey)):
        try:
            oKey = winreg.EnumKey(key, i)          
            val = ReadReg(path + '\\' + oKey,'DisplayName')
            if not val: continue;            
            num = 0
            for name in arrs:
                if val.find(name) >= 0:
                    num += 1
                else:
                    num = 0;           
            if len(arrs) == num: return True;
        except :
            continue
    return False

#根据多个内容匹配
def isAppSetup(arrs):   
    rRet = get_appSetup(r'SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall',arrs)
    if not rRet:
        if is_64bitos(): rRet = get_appSetup(r'SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Uninstall',arrs)      
    return rRet

#根据php获取需要的vc版本
def get_vc_version(phpVersion):
    version = '2008';
    if phpVersion == '71' or phpVersion == '70':
        version = '2015'           
    elif phpVersion == '56' or phpVersion == '55':
        version = '2012'
    return version

#检测vc版本
def check_setup_vc(phpVersion):
    #bit = ' x64' if is_64bitos() else ' x86'
    arrs = ['Visual C++','x86']
    if phpVersion == '71' or phpVersion == '70':
        arrs.append("2015")         
    elif phpVersion == '56' or phpVersion == '55':
        arrs.append("2012")
    else:
        arrs.append("2008")        
    return isAppSetup(arrs)


#安装vc++
def setup_vc(version, bit = 'x64'):
   download_url = get_url()
   tmpPath = 'C:/temp'
   if not os.path.exists(tmpPath): os.makedirs(tmpPath)      
   temp = tmpPath + '/vc'+ version + '_' + 'x86' + '.exe'  
   downloadFile(download_url + '/win/vc/vcredist_'+ version +'_'+ 'x86' +'.exe',temp)
   if not os.path.exists(temp): 
       return False
   ExecShell(temp + ' /q')
   return True


#从文件读取xml转为json对象
def loads_json(xml_path):
    data = {}
    try:
        xml_str = readFile(xml_path)
        data = xmltodict.parse(xml_str)
    except :  pass
    return data

#json对象转为xml文件
def dumps_json(jsonstr):
    xmlstr = xmltodict.unparse(jsonstr)
    return xmlstr

#格式化xml
def format_xml(xmlStr):
    b = minidom.parseString(xmlStr)
    c = b.toprettyxml(indent = "\t")
    return c

def get_pip_list():
    rRet = ExecShell('pip list')

    list = rRet[0].split('\r\n')
    import re
    data = {}
    i = 0;
    for x in list:
        if i > 1:       
            temp = re.search('([\w-]+)\s+([\d\.]+)',x)
            if temp:
                key = temp.groups()[0]
                version = temp.groups()[1]
 
                item = {}
                item['version'] = version
                data[key] = item
        i += 1
    return data


